diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-ue-rrc.cc ns-3.40/src/lte/model/lte-ue-rrc.cc
--- ns-3.39/src/lte/model/lte-ue-rrc.cc	2023-07-05 14:23:48.017428200 -0700
+++ ns-3.40/src/lte/model/lte-ue-rrc.cc	2023-09-27 13:30:37.826839700 -0700
@@ -591,7 +591,7 @@
 
     if (drbid != 0)
     {
-        std::map<uint8_t, Ptr<LteDataRadioBearerInfo>>::iterator it = m_drbMap.find(drbid);
+        auto it = m_drbMap.find(drbid);
         NS_ASSERT_MSG(it != m_drbMap.end(), "could not find bearer with drbid == " << drbid);
 
         LtePdcpSapProvider::TransmitPdcpSduParameters params;
@@ -681,8 +681,7 @@
         m_rrcSapUser->SendRrcConnectionReconfigurationCompleted(msg);
 
         // 3GPP TS 36.331 section 5.5.6.1 Measurements related actions upon handover
-        std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt;
-        for (measIdIt = m_varMeasConfig.measIdList.begin();
+        for (auto measIdIt = m_varMeasConfig.measIdList.begin();
              measIdIt != m_varMeasConfig.measIdList.end();
              ++measIdIt)
         {
@@ -917,8 +916,7 @@
     // layer 3 filtering does not apply in IDLE mode
     bool useLayer3Filtering = (m_state == CONNECTED_NORMALLY);
     bool triggering = true;
-    std::vector<LteUeCphySapUser::UeMeasurementsElement>::iterator newMeasIt;
-    for (newMeasIt = params.m_ueMeasurementsList.begin();
+    for (auto newMeasIt = params.m_ueMeasurementsList.begin();
          newMeasIt != params.m_ueMeasurementsList.end();
          ++newMeasIt)
     {
@@ -943,8 +941,7 @@
     {
         if (triggering)
         {
-            std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt;
-            for (measIdIt = m_varMeasConfig.measIdList.begin();
+            for (auto measIdIt = m_varMeasConfig.measIdList.begin();
                  measIdIt != m_varMeasConfig.measIdList.end();
                  ++measIdIt)
             {
@@ -1248,8 +1245,7 @@
     double maxRsrp = -std::numeric_limits<double>::infinity();
     double minRsrp = -140.0; // Minimum RSRP in dBm a UE can report
 
-    std::map<uint16_t, MeasValues>::iterator it;
-    for (it = m_storedMeasValues.begin(); it != m_storedMeasValues.end(); it++)
+    for (auto it = m_storedMeasValues.begin(); it != m_storedMeasValues.end(); it++)
     {
         /*
          * This block attempts to find a cell with strongest RSRP and has not
@@ -1257,8 +1253,7 @@
          */
         if (maxRsrp < it->second.rsrp && it->second.rsrp > minRsrp)
         {
-            std::set<uint16_t>::const_iterator itCell;
-            itCell = m_acceptableCell.find(it->first);
+            auto itCell = m_acceptableCell.find(it->first);
             if (itCell == m_acceptableCell.end())
             {
                 maxRsrpCellId = it->first;
@@ -1294,7 +1289,7 @@
 
     bool isSuitableCell = false;
     bool isAcceptableCell = false;
-    std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.find(cellId);
+    auto storedMeasIt = m_storedMeasValues.find(cellId);
     double qRxLevMeas = storedMeasIt->second.rsrp;
     double qRxLevMin =
         EutranMeasurementMapping::IeValue2ActualQRxLevMin(m_lastSib1.cellSelectionInfo.qRxLevMin);
@@ -1437,7 +1432,7 @@
         m_cphySapProvider.at(0)->SetPa(paDouble);
     }
 
-    std::list<LteRrcSap::SrbToAddMod>::const_iterator stamIt = rrcd.srbToAddModList.begin();
+    auto stamIt = rrcd.srbToAddModList.begin();
     if (stamIt != rrcd.srbToAddModList.end())
     {
         if (!m_srb1)
@@ -1498,8 +1493,7 @@
         }
     }
 
-    std::list<LteRrcSap::DrbToAddMod>::const_iterator dtamIt;
-    for (dtamIt = rrcd.drbToAddModList.begin(); dtamIt != rrcd.drbToAddModList.end(); ++dtamIt)
+    for (auto dtamIt = rrcd.drbToAddModList.begin(); dtamIt != rrcd.drbToAddModList.end(); ++dtamIt)
     {
         NS_LOG_INFO(this << " IMSI " << m_imsi << " adding/modifying DRBID "
                          << (uint32_t)dtamIt->drbIdentity << " LC "
@@ -1507,8 +1501,7 @@
         NS_ASSERT_MSG(dtamIt->logicalChannelIdentity > 2,
                       "LCID value " << dtamIt->logicalChannelIdentity << " is reserved for SRBs");
 
-        std::map<uint8_t, Ptr<LteDataRadioBearerInfo>>::iterator drbMapIt =
-            m_drbMap.find(dtamIt->drbIdentity);
+        auto drbMapIt = m_drbMap.find(dtamIt->drbIdentity);
         if (drbMapIt == m_drbMap.end())
         {
             NS_LOG_INFO("New Data Radio Bearer");
@@ -1585,8 +1578,7 @@
                                            rlc->GetLteMacSapUser());
 
             NS_LOG_DEBUG("Size of lcOnCcMapping vector " << lcOnCcMapping.size());
-            std::vector<LteUeCcmRrcSapProvider::LcsConfig>::iterator itLcOnCcMapping =
-                lcOnCcMapping.begin();
+            auto itLcOnCcMapping = lcOnCcMapping.begin();
             NS_ASSERT_MSG(itLcOnCcMapping != lcOnCcMapping.end(),
                           "Component carrier manager failed to add LC for data radio bearer");
 
@@ -1617,12 +1609,12 @@
         }
     }
 
-    std::list<uint8_t>::iterator dtdmIt;
-    for (dtdmIt = rrcd.drbToReleaseList.begin(); dtdmIt != rrcd.drbToReleaseList.end(); ++dtdmIt)
+    for (auto dtdmIt = rrcd.drbToReleaseList.begin(); dtdmIt != rrcd.drbToReleaseList.end();
+         ++dtdmIt)
     {
         uint8_t drbid = *dtdmIt;
         NS_LOG_INFO(this << " IMSI " << m_imsi << " releasing DRB " << (uint32_t)drbid);
-        std::map<uint8_t, Ptr<LteDataRadioBearerInfo>>::iterator it = m_drbMap.find(drbid);
+        auto it = m_drbMap.find(drbid);
         NS_ASSERT_MSG(it != m_drbMap.end(), "could not find bearer with given lcid");
         m_drbMap.erase(it);
         m_bid2DrbidMap.erase(drbid);
@@ -1642,15 +1634,12 @@
     // perform the actions specified in 3GPP TS 36.331 section 5.5.2.1
 
     // 3GPP TS 36.331 section 5.5.2.4 Measurement object removal
-    for (std::list<uint8_t>::iterator it = mc.measObjectToRemoveList.begin();
-         it != mc.measObjectToRemoveList.end();
-         ++it)
+    for (auto it = mc.measObjectToRemoveList.begin(); it != mc.measObjectToRemoveList.end(); ++it)
     {
         uint8_t measObjectId = *it;
         NS_LOG_LOGIC(this << " deleting measObjectId " << (uint32_t)measObjectId);
         m_varMeasConfig.measObjectList.erase(measObjectId);
-        std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt =
-            m_varMeasConfig.measIdList.begin();
+        auto measIdIt = m_varMeasConfig.measIdList.begin();
         while (measIdIt != m_varMeasConfig.measIdList.end())
         {
             if (measIdIt->second.measObjectId == measObjectId)
@@ -1672,9 +1661,7 @@
     }
 
     // 3GPP TS 36.331 section 5.5.2.5  Measurement object addition/ modification
-    for (std::list<LteRrcSap::MeasObjectToAddMod>::iterator it = mc.measObjectToAddModList.begin();
-         it != mc.measObjectToAddModList.end();
-         ++it)
+    for (auto it = mc.measObjectToAddModList.begin(); it != mc.measObjectToAddModList.end(); ++it)
     {
         // simplifying assumptions
         NS_ASSERT_MSG(it->measObjectEutra.cellsToRemoveList.empty(),
@@ -1689,14 +1676,12 @@
                       "cellForWhichToReportCGI is not supported");
 
         uint8_t measObjectId = it->measObjectId;
-        std::map<uint8_t, LteRrcSap::MeasObjectToAddMod>::iterator measObjectIt =
-            m_varMeasConfig.measObjectList.find(measObjectId);
+        auto measObjectIt = m_varMeasConfig.measObjectList.find(measObjectId);
         if (measObjectIt != m_varMeasConfig.measObjectList.end())
         {
             NS_LOG_LOGIC("measObjectId " << (uint32_t)measObjectId << " exists, updating entry");
             measObjectIt->second = *it;
-            for (std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt =
-                     m_varMeasConfig.measIdList.begin();
+            for (auto measIdIt = m_varMeasConfig.measIdList.begin();
                  measIdIt != m_varMeasConfig.measIdList.end();
                  ++measIdIt)
             {
@@ -1717,15 +1702,13 @@
     }
 
     // 3GPP TS 36.331 section 5.5.2.6 Reporting configuration removal
-    for (std::list<uint8_t>::iterator it = mc.reportConfigToRemoveList.begin();
-         it != mc.reportConfigToRemoveList.end();
+    for (auto it = mc.reportConfigToRemoveList.begin(); it != mc.reportConfigToRemoveList.end();
          ++it)
     {
         uint8_t reportConfigId = *it;
         NS_LOG_LOGIC(this << " deleting reportConfigId " << (uint32_t)reportConfigId);
         m_varMeasConfig.reportConfigList.erase(reportConfigId);
-        std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt =
-            m_varMeasConfig.measIdList.begin();
+        auto measIdIt = m_varMeasConfig.measIdList.begin();
         while (measIdIt != m_varMeasConfig.measIdList.end())
         {
             if (measIdIt->second.reportConfigId == reportConfigId)
@@ -1747,9 +1730,7 @@
     }
 
     // 3GPP TS 36.331 section 5.5.2.7 Reporting configuration addition/ modification
-    for (std::list<LteRrcSap::ReportConfigToAddMod>::iterator it =
-             mc.reportConfigToAddModList.begin();
-         it != mc.reportConfigToAddModList.end();
+    for (auto it = mc.reportConfigToAddModList.begin(); it != mc.reportConfigToAddModList.end();
          ++it)
     {
         // simplifying assumptions
@@ -1757,15 +1738,13 @@
                       "only trigger type EVENT is supported");
 
         uint8_t reportConfigId = it->reportConfigId;
-        std::map<uint8_t, LteRrcSap::ReportConfigToAddMod>::iterator reportConfigIt =
-            m_varMeasConfig.reportConfigList.find(reportConfigId);
+        auto reportConfigIt = m_varMeasConfig.reportConfigList.find(reportConfigId);
         if (reportConfigIt != m_varMeasConfig.reportConfigList.end())
         {
             NS_LOG_LOGIC("reportConfigId " << (uint32_t)reportConfigId
                                            << " exists, updating entry");
             m_varMeasConfig.reportConfigList[reportConfigId] = *it;
-            for (std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt =
-                     m_varMeasConfig.measIdList.begin();
+            for (auto measIdIt = m_varMeasConfig.measIdList.begin();
                  measIdIt != m_varMeasConfig.measIdList.end();
                  ++measIdIt)
             {
@@ -1805,8 +1784,7 @@
         NS_LOG_LOGIC(this << " new filter coefficients: aRsrp=" << m_varMeasConfig.aRsrp
                           << ", aRsrq=" << m_varMeasConfig.aRsrq);
 
-        for (std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt =
-                 m_varMeasConfig.measIdList.begin();
+        for (auto measIdIt = m_varMeasConfig.measIdList.begin();
              measIdIt != m_varMeasConfig.measIdList.end();
              ++measIdIt)
         {
@@ -1815,9 +1793,7 @@
     }
 
     // 3GPP TS 36.331 section 5.5.2.2 Measurement identity removal
-    for (std::list<uint8_t>::iterator it = mc.measIdToRemoveList.begin();
-         it != mc.measIdToRemoveList.end();
-         ++it)
+    for (auto it = mc.measIdToRemoveList.begin(); it != mc.measIdToRemoveList.end(); ++it)
     {
         uint8_t measId = *it;
         NS_LOG_LOGIC(this << " deleting measId " << (uint32_t)measId);
@@ -1830,9 +1806,7 @@
     }
 
     // 3GPP TS 36.331 section 5.5.2.3 Measurement identity addition/ modification
-    for (std::list<LteRrcSap::MeasIdToAddMod>::iterator it = mc.measIdToAddModList.begin();
-         it != mc.measIdToAddModList.end();
-         ++it)
+    for (auto it = mc.measIdToAddModList.begin(); it != mc.measIdToAddModList.end(); ++it)
     {
         NS_LOG_LOGIC(this << " measId " << (uint32_t)it->measId
                           << " (measObjectId=" << (uint32_t)it->measObjectId
@@ -1842,8 +1816,7 @@
         NS_ASSERT(m_varMeasConfig.reportConfigList.find(it->reportConfigId) !=
                   m_varMeasConfig.reportConfigList.end());
         m_varMeasConfig.measIdList[it->measId] = *it; // side effect: create new entry if not exists
-        std::map<uint8_t, VarMeasReport>::iterator measReportIt =
-            m_varMeasReportList.find(it->measId);
+        auto measReportIt = m_varMeasReportList.find(it->measId);
         if (measReportIt != m_varMeasReportList.end())
         {
             measReportIt->second.periodicReportTimer.Cancel();
@@ -1884,7 +1857,7 @@
 {
     NS_LOG_FUNCTION(this << cellId << +componentCarrierId << rsrp << rsrq << useLayer3Filtering);
 
-    std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.find(cellId);
+    auto storedMeasIt = m_storedMeasValues.find(cellId);
 
     if (storedMeasIt != m_storedMeasValues.end())
     {
@@ -1921,8 +1894,7 @@
         v.carrierFreq = m_cphySapProvider.at(componentCarrierId)->GetDlEarfcn();
 
         std::pair<uint16_t, MeasValues> val(cellId, v);
-        std::pair<std::map<uint16_t, MeasValues>::iterator, bool> ret =
-            m_storedMeasValues.insert(val);
+        auto ret = m_storedMeasValues.insert(val);
         NS_ASSERT_MSG(ret.second == true, "element already existed");
         storedMeasIt = ret.first;
     }
@@ -1939,22 +1911,19 @@
 {
     NS_LOG_FUNCTION(this << (uint16_t)measId);
 
-    std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt =
-        m_varMeasConfig.measIdList.find(measId);
+    auto measIdIt = m_varMeasConfig.measIdList.find(measId);
     NS_ASSERT(measIdIt != m_varMeasConfig.measIdList.end());
     NS_ASSERT(measIdIt->first == measIdIt->second.measId);
 
-    std::map<uint8_t, LteRrcSap::ReportConfigToAddMod>::iterator reportConfigIt =
-        m_varMeasConfig.reportConfigList.find(measIdIt->second.reportConfigId);
+    auto reportConfigIt = m_varMeasConfig.reportConfigList.find(measIdIt->second.reportConfigId);
     NS_ASSERT(reportConfigIt != m_varMeasConfig.reportConfigList.end());
     LteRrcSap::ReportConfigEutra& reportConfigEutra = reportConfigIt->second.reportConfigEutra;
 
-    std::map<uint8_t, LteRrcSap::MeasObjectToAddMod>::iterator measObjectIt =
-        m_varMeasConfig.measObjectList.find(measIdIt->second.measObjectId);
+    auto measObjectIt = m_varMeasConfig.measObjectList.find(measIdIt->second.measObjectId);
     NS_ASSERT(measObjectIt != m_varMeasConfig.measObjectList.end());
     LteRrcSap::MeasObjectEutra& measObjectEutra = measObjectIt->second.measObjectEutra;
 
-    std::map<uint8_t, VarMeasReport>::iterator measReportIt = m_varMeasReportList.find(measId);
+    auto measReportIt = m_varMeasReportList.find(measId);
     bool isMeasIdInReportList = (measReportIt != m_varMeasReportList.end());
 
     // we don't check the purpose field, as it is only included for
@@ -2202,7 +2171,7 @@
             break;
         }
 
-        for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin();
+        for (auto storedMeasIt = m_storedMeasValues.begin();
              storedMeasIt != m_storedMeasValues.end();
              ++storedMeasIt)
         {
@@ -2310,7 +2279,7 @@
             break;
         }
 
-        for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin();
+        for (auto storedMeasIt = m_storedMeasValues.begin();
              storedMeasIt != m_storedMeasValues.end();
              ++storedMeasIt)
         {
@@ -2427,7 +2396,7 @@
 
         if (entryCond)
         {
-            for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin();
+            for (auto storedMeasIt = m_storedMeasValues.begin();
                  storedMeasIt != m_storedMeasValues.end();
                  ++storedMeasIt)
             {
@@ -2500,8 +2469,7 @@
                 {
                     // leaving condition #2 does not have to be checked
 
-                    for (std::map<uint16_t, MeasValues>::iterator storedMeasIt =
-                             m_storedMeasValues.begin();
+                    for (auto storedMeasIt = m_storedMeasValues.begin();
                          storedMeasIt != m_storedMeasValues.end();
                          ++storedMeasIt)
                     {
@@ -2523,8 +2491,7 @@
                 {
                     // leaving condition #2 has to be checked to cancel time-to-trigger
 
-                    for (std::map<uint16_t, MeasValues>::iterator storedMeasIt =
-                             m_storedMeasValues.begin();
+                    for (auto storedMeasIt = m_storedMeasValues.begin();
                          storedMeasIt != m_storedMeasValues.end();
                          ++storedMeasIt)
                     {
@@ -2592,8 +2559,7 @@
 
                 // check leaving condition #2
 
-                for (std::map<uint16_t, MeasValues>::iterator storedMeasIt =
-                         m_storedMeasValues.begin();
+                for (auto storedMeasIt = m_storedMeasValues.begin();
                      storedMeasIt != m_storedMeasValues.end();
                      ++storedMeasIt)
                 {
@@ -2670,8 +2636,7 @@
                                           this,
                                           measId,
                                           concernedCellsEntry);
-            std::map<uint8_t, std::list<PendingTrigger_t>>::iterator enteringTriggerIt =
-                m_enteringTriggerQueue.find(measId);
+            auto enteringTriggerIt = m_enteringTriggerQueue.find(measId);
             NS_ASSERT(enteringTriggerIt != m_enteringTriggerQueue.end());
             enteringTriggerIt->second.push_back(t);
         }
@@ -2699,8 +2664,7 @@
                                           measId,
                                           concernedCellsLeaving,
                                           reportOnLeave);
-            std::map<uint8_t, std::list<PendingTrigger_t>>::iterator leavingTriggerIt =
-                m_leavingTriggerQueue.find(measId);
+            auto leavingTriggerIt = m_leavingTriggerQueue.find(measId);
             NS_ASSERT(leavingTriggerIt != m_leavingTriggerQueue.end());
             leavingTriggerIt->second.push_back(t);
         }
@@ -2713,14 +2677,12 @@
 {
     NS_LOG_FUNCTION(this << (uint16_t)measId);
 
-    std::map<uint8_t, std::list<PendingTrigger_t>>::iterator it1 =
-        m_enteringTriggerQueue.find(measId);
+    auto it1 = m_enteringTriggerQueue.find(measId);
     NS_ASSERT(it1 != m_enteringTriggerQueue.end());
 
     if (!it1->second.empty())
     {
-        std::list<PendingTrigger_t>::iterator it2;
-        for (it2 = it1->second.begin(); it2 != it1->second.end(); ++it2)
+        for (auto it2 = it1->second.begin(); it2 != it1->second.end(); ++it2)
         {
             NS_ASSERT(it2->measId == measId);
             NS_LOG_LOGIC(this << " canceling entering time-to-trigger event at "
@@ -2737,17 +2699,15 @@
 {
     NS_LOG_FUNCTION(this << (uint16_t)measId << cellId);
 
-    std::map<uint8_t, std::list<PendingTrigger_t>>::iterator it1 =
-        m_enteringTriggerQueue.find(measId);
+    auto it1 = m_enteringTriggerQueue.find(measId);
     NS_ASSERT(it1 != m_enteringTriggerQueue.end());
 
-    std::list<PendingTrigger_t>::iterator it2 = it1->second.begin();
+    auto it2 = it1->second.begin();
     while (it2 != it1->second.end())
     {
         NS_ASSERT(it2->measId == measId);
 
-        ConcernedCells_t::iterator it3;
-        for (it3 = it2->concernedCells.begin(); it3 != it2->concernedCells.end(); ++it3)
+        for (auto it3 = it2->concernedCells.begin(); it3 != it2->concernedCells.end(); ++it3)
         {
             if (*it3 == cellId)
             {
@@ -2774,14 +2734,12 @@
 {
     NS_LOG_FUNCTION(this << (uint16_t)measId);
 
-    std::map<uint8_t, std::list<PendingTrigger_t>>::iterator it1 =
-        m_leavingTriggerQueue.find(measId);
+    auto it1 = m_leavingTriggerQueue.find(measId);
     NS_ASSERT(it1 != m_leavingTriggerQueue.end());
 
     if (!it1->second.empty())
     {
-        std::list<PendingTrigger_t>::iterator it2;
-        for (it2 = it1->second.begin(); it2 != it1->second.end(); ++it2)
+        for (auto it2 = it1->second.begin(); it2 != it1->second.end(); ++it2)
         {
             NS_ASSERT(it2->measId == measId);
             NS_LOG_LOGIC(this << " canceling leaving time-to-trigger event at "
@@ -2798,17 +2756,15 @@
 {
     NS_LOG_FUNCTION(this << (uint16_t)measId << cellId);
 
-    std::map<uint8_t, std::list<PendingTrigger_t>>::iterator it1 =
-        m_leavingTriggerQueue.find(measId);
+    auto it1 = m_leavingTriggerQueue.find(measId);
     NS_ASSERT(it1 != m_leavingTriggerQueue.end());
 
-    std::list<PendingTrigger_t>::iterator it2 = it1->second.begin();
+    auto it2 = it1->second.begin();
     while (it2 != it1->second.end())
     {
         NS_ASSERT(it2->measId == measId);
 
-        ConcernedCells_t::iterator it3;
-        for (it3 = it2->concernedCells.begin(); it3 != it2->concernedCells.end(); ++it3)
+        for (auto it3 = it2->concernedCells.begin(); it3 != it2->concernedCells.end(); ++it3)
         {
             if (*it3 == cellId)
             {
@@ -2836,23 +2792,21 @@
     NS_LOG_FUNCTION(this << (uint16_t)measId);
     NS_ASSERT(!enteringCells.empty());
 
-    std::map<uint8_t, VarMeasReport>::iterator measReportIt = m_varMeasReportList.find(measId);
+    auto measReportIt = m_varMeasReportList.find(measId);
 
     if (measReportIt == m_varMeasReportList.end())
     {
         VarMeasReport r;
         r.measId = measId;
         std::pair<uint8_t, VarMeasReport> val(measId, r);
-        std::pair<std::map<uint8_t, VarMeasReport>::iterator, bool> ret =
-            m_varMeasReportList.insert(val);
+        auto ret = m_varMeasReportList.insert(val);
         NS_ASSERT_MSG(ret.second == true, "element already existed");
         measReportIt = ret.first;
     }
 
     NS_ASSERT(measReportIt != m_varMeasReportList.end());
 
-    for (ConcernedCells_t::const_iterator it = enteringCells.begin(); it != enteringCells.end();
-         ++it)
+    for (auto it = enteringCells.begin(); it != enteringCells.end(); ++it)
     {
         measReportIt->second.cellsTriggeredList.insert(*it);
     }
@@ -2870,8 +2824,7 @@
                                 measId);
     }
 
-    std::map<uint8_t, std::list<PendingTrigger_t>>::iterator enteringTriggerIt =
-        m_enteringTriggerQueue.find(measId);
+    auto enteringTriggerIt = m_enteringTriggerQueue.find(measId);
     NS_ASSERT(enteringTriggerIt != m_enteringTriggerQueue.end());
     if (!enteringTriggerIt->second.empty())
     {
@@ -2890,9 +2843,7 @@
              * we clean up the time-to-trigger queue. This case might occur when
              * time-to-trigger > 200 ms.
              */
-            for (ConcernedCells_t::const_iterator it = enteringCells.begin();
-                 it != enteringCells.end();
-                 ++it)
+            for (auto it = enteringCells.begin(); it != enteringCells.end(); ++it)
             {
                 CancelEnteringTrigger(measId, *it);
             }
@@ -2908,10 +2859,10 @@
     NS_LOG_FUNCTION(this << (uint16_t)measId);
     NS_ASSERT(!leavingCells.empty());
 
-    std::map<uint8_t, VarMeasReport>::iterator measReportIt = m_varMeasReportList.find(measId);
+    auto measReportIt = m_varMeasReportList.find(measId);
     NS_ASSERT(measReportIt != m_varMeasReportList.end());
 
-    for (ConcernedCells_t::const_iterator it = leavingCells.begin(); it != leavingCells.end(); ++it)
+    for (auto it = leavingCells.begin(); it != leavingCells.end(); ++it)
     {
         measReportIt->second.cellsTriggeredList.erase(*it);
     }
@@ -2928,8 +2879,7 @@
         m_varMeasReportList.erase(measReportIt);
     }
 
-    std::map<uint8_t, std::list<PendingTrigger_t>>::iterator leavingTriggerIt =
-        m_leavingTriggerQueue.find(measId);
+    auto leavingTriggerIt = m_leavingTriggerQueue.find(measId);
     NS_ASSERT(leavingTriggerIt != m_leavingTriggerQueue.end());
     if (!leavingTriggerIt->second.empty())
     {
@@ -2948,9 +2898,7 @@
              * we clean up the time-to-trigger queue. This case might occur when
              * time-to-trigger > 200 ms.
              */
-            for (ConcernedCells_t::const_iterator it = leavingCells.begin();
-                 it != leavingCells.end();
-                 ++it)
+            for (auto it = leavingCells.begin(); it != leavingCells.end(); ++it)
             {
                 CancelLeavingTrigger(measId, *it);
             }
@@ -2966,7 +2914,7 @@
     NS_LOG_FUNCTION(this << (uint16_t)measId);
 
     // remove the measurement reporting entry for this measId from the VarMeasReportList
-    std::map<uint8_t, VarMeasReport>::iterator measReportIt = m_varMeasReportList.find(measId);
+    auto measReportIt = m_varMeasReportList.find(measId);
     if (measReportIt != m_varMeasReportList.end())
     {
         NS_LOG_LOGIC(this << " deleting existing report for measId " << (uint16_t)measId);
@@ -2984,12 +2932,10 @@
     NS_LOG_FUNCTION(this << (uint16_t)measId);
     //  3GPP TS 36.331 section 5.5.5 Measurement reporting
 
-    std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt =
-        m_varMeasConfig.measIdList.find(measId);
+    auto measIdIt = m_varMeasConfig.measIdList.find(measId);
     NS_ASSERT(measIdIt != m_varMeasConfig.measIdList.end());
 
-    std::map<uint8_t, LteRrcSap::ReportConfigToAddMod>::iterator reportConfigIt =
-        m_varMeasConfig.reportConfigList.find(measIdIt->second.reportConfigId);
+    auto reportConfigIt = m_varMeasConfig.reportConfigList.find(measIdIt->second.reportConfigId);
     NS_ASSERT(reportConfigIt != m_varMeasConfig.reportConfigList.end());
     LteRrcSap::ReportConfigEutra& reportConfigEutra = reportConfigIt->second.reportConfigEutra;
 
@@ -2997,14 +2943,14 @@
     LteRrcSap::MeasResults& measResults = measurementReport.measResults;
     measResults.measId = measId;
 
-    std::map<uint8_t, VarMeasReport>::iterator measReportIt = m_varMeasReportList.find(measId);
+    auto measReportIt = m_varMeasReportList.find(measId);
     if (measReportIt == m_varMeasReportList.end())
     {
         NS_LOG_ERROR("no entry found in m_varMeasReportList for measId " << (uint32_t)measId);
     }
     else
     {
-        std::map<uint16_t, MeasValues>::iterator servingMeasIt = m_storedMeasValues.find(m_cellId);
+        auto servingMeasIt = m_storedMeasValues.find(m_cellId);
         NS_ASSERT(servingMeasIt != m_storedMeasValues.end());
         measResults.measResultPCell.rsrpResult =
             EutranMeasurementMapping::Dbm2RsrpRange(servingMeasIt->second.rsrp);
@@ -3045,16 +2991,14 @@
         if (!(measReportIt->second.cellsTriggeredList.empty()))
         {
             std::multimap<double, uint16_t> sortedNeighCells;
-            for (std::set<uint16_t>::iterator cellsTriggeredIt =
-                     measReportIt->second.cellsTriggeredList.begin();
+            for (auto cellsTriggeredIt = measReportIt->second.cellsTriggeredList.begin();
                  cellsTriggeredIt != measReportIt->second.cellsTriggeredList.end();
                  ++cellsTriggeredIt)
             {
                 uint16_t cellId = *cellsTriggeredIt;
                 if (cellId != m_cellId)
                 {
-                    std::map<uint16_t, MeasValues>::iterator neighborMeasIt =
-                        m_storedMeasValues.find(cellId);
+                    auto neighborMeasIt = m_storedMeasValues.find(cellId);
                     double triggerValue;
                     switch (reportConfigEutra.triggerQuantity)
                     {
@@ -3080,8 +3024,7 @@
                  ++sortedNeighCellsIt, ++count)
             {
                 uint16_t cellId = sortedNeighCellsIt->second;
-                std::map<uint16_t, MeasValues>::iterator neighborMeasIt =
-                    m_storedMeasValues.find(cellId);
+                auto neighborMeasIt = m_storedMeasValues.find(cellId);
                 NS_ASSERT(neighborMeasIt != m_storedMeasValues.end());
                 LteRrcSap::MeasResultEutra measResultEutra;
                 measResultEutra.physCellId = cellId;
@@ -3191,8 +3134,7 @@
     m_storedMeasValues.clear();
     ResetRlfParams();
 
-    std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt;
-    for (measIdIt = m_varMeasConfig.measIdList.begin();
+    for (auto measIdIt = m_varMeasConfig.measIdList.begin();
          measIdIt != m_varMeasConfig.measIdList.end();
          ++measIdIt)
     {
@@ -3268,7 +3210,7 @@
 uint8_t
 LteUeRrc::Bid2Drbid(uint8_t bid)
 {
-    std::map<uint8_t, uint8_t>::iterator it = m_bid2DrbidMap.find(bid);
+    auto it = m_bid2DrbidMap.find(bid);
     // NS_ASSERT_MSG (it != m_bid2DrbidMap.end (), "could not find BID " << bid);
     if (it == m_bid2DrbidMap.end())
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/no-op-component-carrier-manager.cc ns-3.40/src/lte/model/no-op-component-carrier-manager.cc
--- ns-3.39/src/lte/model/no-op-component-carrier-manager.cc	2023-07-05 14:23:48.017428200 -0700
+++ ns-3.40/src/lte/model/no-op-component-carrier-manager.cc	2023-09-27 13:30:37.826839700 -0700
@@ -81,8 +81,7 @@
 NoOpComponentCarrierManager::DoTransmitPdu(LteMacSapProvider::TransmitPduParameters params)
 {
     NS_LOG_FUNCTION(this);
-    std::map<uint8_t, LteMacSapProvider*>::iterator it =
-        m_macSapProvidersMap.find(params.componentCarrierId);
+    auto it = m_macSapProvidersMap.find(params.componentCarrierId);
     NS_ASSERT_MSG(it != m_macSapProvidersMap.end(),
                   "could not find Sap for ComponentCarrier " << params.componentCarrierId);
     // with this algorithm all traffic is on Primary Carrier
@@ -95,8 +94,7 @@
 {
     NS_LOG_FUNCTION(this);
     auto ueManager = m_ccmRrcSapUser->GetUeManager(params.rnti);
-    std::map<uint8_t, LteMacSapProvider*>::iterator it =
-        m_macSapProvidersMap.find(ueManager->GetComponentCarrierId());
+    auto it = m_macSapProvidersMap.find(ueManager->GetComponentCarrierId());
     NS_ASSERT_MSG(it != m_macSapProvidersMap.end(), "could not find Sap for ComponentCarrier ");
     it->second->ReportBufferStatus(params);
 }
@@ -138,7 +136,6 @@
 NoOpComponentCarrierManager::DoAddUe(uint16_t rnti, uint8_t state)
 {
     NS_LOG_FUNCTION(this << rnti << (uint16_t)state);
-    std::map<uint16_t, uint8_t>::iterator eccIt; // m_enabledComponentCarrier iterator
     auto ueInfoIt = m_ueInfo.find(rnti);
     if (ueInfoIt == m_ueInfo.end())
     {
